import cProfile, sys
from mpi4py import MPI
import numpy as np

comm = MPI.COMM_WORLD
rank = comm.Get_rank()
size = comm.Get_size()


time = MPI.Wtime()

pr = cProfile.Profile()
pr.enable()

if rank == 0:
    # in real code, this section might
    # read in data parameters from a file
    numData = 10  
    comm.send(numData, dest=1)

    data = np.linspace(0.0,3.14,numData)  
    comm.Send(data, dest=1)

elif rank == 1:

    numData = comm.recv(source=0)
    print('Number of data to receive: ',numData)

    data = np.empty(numData, dtype='d')  # allocate space to receive the array
    comm.Recv(data, source=0)

    print('data received: ',data)

pr.disable()


pr.dump_stats('cpu_%d.prof' %comm.rank)

with open('cpu_%d.txt' %comm.rank, 'w') as output_file:
     sys.stdout = output_file
     pr.print_stats( sort = 'time')
     sys.stdout = sys.__stdout__


time1 = MPI.Wtime()

time3 = time1-time

if rank == 0:
   print ('Time Taken: ', time3)
